/*
Copyright (c) 1997-2000,KeeBoo Corporation. All rights reserved.
Copyright application on progress at the Copyright Office.
This source code is the property of KeeBoo Corporation,
it cannot be reused,modified or published without prior 
written consent from KeeBoo Corporation.
KeeBoo and the KeeBoo logo are trademarks or registered
trademarks of KeeBoo Corporation.
*/

var _charCodes=""
var _idCounter=1

function extrPath(path)
{ 
	path=path.replace(/\\/g,"/")
	if (_ns&&(path[path.length-1]=='/')) return path
	path=path.slice(0,path.lastIndexOf("/"))+"/"
	return path.replace(new RegExp("'","g"),escape("'"))
}

function getPath(doc)
{ 
	var path=doc.location.href
	return extrPath(path)
}

function calPath(root,path,addSlash)
{
	if (addSlash==_NULL) addSlash=true
	var rel=true

	if ((path.slice(0,1)=='/')||(path.slice(0,5)=='http:')||(path.slice(0,6)=='https:')||(path.slice(0,5)=='file:')) rel=false
	if ((addSlash)&&(path.slice(path.length - 1,path.length)!='/')) path+='/'
	if (root.slice(root.length - 1,root.length)!='/') root+='/'
	if (rel) path=root+path
	return path.replace(new RegExp("'","g"),escape("'"))
}

function entitifyString(str,allowHTML)
{
	if (str==_NULL) return _NULL
	if (allowHTML==_NULL) allowHTML=false

	var strOut="",c,code
	for (i=0;i<str.length;i++)
	{
		c=str.charAt(i)
		code=str.charCodeAt(i)
		
		if (_macIE)
		{
			if (code>127) c="&#"+code+";"	
			if (code<0) c="&#"+(256+code)+";"
		}
		if (_macNS) c=translateChar(c)

		if (!allowHTML)
		{
			if (c=="<") c="&lt;"
			if (c==">") c="&gt;"
			if (c=="&") c="&amp;"
		}
		strOut+=c
	}
	return strOut
}

function translateChar(c)
{
	if (_globalStringTable)
	{
		var index=_charCodes.indexOf(c)
		if (index>0) return _globalStringTable.charAt(index)
	}
	return c
}

function _KB_Engine()
{
	this.KBCreateBook=createBook
}

function _KB_Author()
{
	this.name=_NULL
	this.email=_NULL
	this.photo=_NULL
	this.url=_NULL
	this.tip=_NULL
}

function _KB_Branding()
{
	this.logoPath=_NULL
	this.logoUrl=_NULL
	this.indexPath=_NULL
	this.indexUrl=_NULL
	this.tocPath=_NULL
	this.tocUrl=_NULL
	this.logoTip=_NULL
	this.idxTip=_NULL
	this.tocTip=_NULL

	this.tocW=0
	this.tocH=0
	this.tocFit=true
}

function _KB_Book(title,id)
{
	if  (id==_NULL) id="NULL"
	this.title=entitifyString(title)
	this.oldTitle=title
	this.id=id
	this.author=new _KB_Author
	this.branding=new _KB_Branding
	this.chapter=new _KB_Chapter(_NULL,'')
	this.currentChapter=this.chapter
	this.pages=new Array
	this.tabs=new Array
	this.tabs[0]=1
	this.authorPage=_NULL
	this.tocPage=_NULL
	this.advertPage=_NULL
	this.indexPage=_NULL
	this.externalPageCount=0
	this.internalPageCount=0
	this.KBSetBranding=setBrand
	this.KBSetBrandTocSize=setBrandTocSize
	this.KBSetAuthor=setAuthor
	this.KBInsertPage=insPage
	this.KBInsertPicture=insPict
	this.KBPushChapter=pushCh
	this.KBPopChapter=popCh
	this.KBSetAuthorPage=setAuthPage
	this.KBSetAdvertPage=setAdv
	this.KBOpenBook=openBk
	this.KBOpenToc=openToc
	this.KBCloseToc=closeToc
	this.KBSetTitle=setTit
	this.KBSetBookId=setBkId
	this.KBSetBookID=setBkId
	
	this.params=new Array
	this.setParam=setPar
	this.KBSetDefaultSkin=setDefSkin
	this.KBSetDefaultLanguage=setDefLang
	this.KBSetDefaultPage=setDefPage
	this.KBSetDefaultModePage=setDefMode
	this.KBRelPath=cPath
	this.getPageById=getPgById
}

function getPgById(id,ch)
{
	if (ch==_NULL) ch=this.chapter
	for (var i in ch.items)
	{
		var item=ch.items[i]
		if (item.id==id) return item
		if (item.isChapter)
		{
			var ret=getPgById(id,item)
			if  (ret) return ret
		}
	}
	return _NULL
}

function _KB_Chapter(parent,title,commentText)
{
	this.parent=parent
	this.items=new Array
	this.title=entitifyString(title)
	this.oldTitle=title
	this.isChapter=true
	this.internal='chapter'
	this.page=0
	this.addItem=_KBC_addItem
	this.enhanced=false
	this.commentText=entitifyString(commentText,true)
	this.isInDomain=true
	this.id=_idCounter++
}

function new_KB_Chapter(a,b,c)
{
	return new _KB_Chapter(a,b,c)
}

function _KB_Page(title,url,fileName,internal,enhanced,commentText,biblio,bibUrl)
{
	if (url!=_NULL)
	{
		url=url.replace(new RegExp("'","g"),escape("'"))
		url=url.replace(new RegExp(" ","g"),escape(" "))
	}

	this.title=entitifyString(title)
	this.oldTitle=title
	this.url=url
	this.fileName=fileName
	this.isChapter=false
	this.internal=internal
	this.enhanced=enhanced
	this.commentText=entitifyString(commentText,true)
	this.biblio=entitifyString(biblio)
	this.bibUrl=bibUrl
	this.page=0
	this.isInDomain=sameDomain(this)
	this.KBAddSticker=addSti
	this.id=_idCounter++
}

function new_KB_Page(a,b,c,d,e,f,g,h)
{
	return new _KB_Page(a,b,c,d,e,f,g,h)
}

function _KBC_addItem(book,item)
{
	item.page=book.pages.length
	this.items[this.items.length]=item
	book.pages[book.pages.length]=item
	item.page=book.pages.length
	if (item.isChapter&&item.parent==book.chapter) book.tabs[book.tabs.length]=book.pages.length-1
	if (item.enhanced) for (var chapter=this; chapter!=_NULL; chapter=chapter.parent) chapter.enhanced=true
}

var _currDomain=document.location.hostname
var _prot=document.location.protocol
var _currLocation=_prot+"//"+_currDomain

function sameDomain(page)
{
	with (page)
	{
		if (fileName!="") return true
		if (_prot=="file:") return false
		return (((_currDomain!="")&&(url.indexOf(_currDomain)==0))||(url.indexOf(_currLocation)==0))
	}
}

function createBook(ncase,nshelf,id,title,style,pos)
{
	var book=new _KB_Book(title,id)
	with (book)
	{
		authorPage=new _KB_Page(_NULL,_NULL,_NULL,'author',false)
		tocPage=new _KB_Page(_NULL,_NULL,_NULL,'toc',false)
		chapter.addItem(book,book.authorPage)
		chapter.addItem(book,book.tocPage)
	}
	return book
}

function setBrandTocSize(fit,w,h)
{
	with (this.branding)
	{
		tocW=w
		tocH=h
		tocFit=fit
	}
}

function setBrand(p_logoPath,p_logoUrl,p_indexPath,p_indexUrl,p_tocPath,p_tocUrl,p_logoTip,p_idxTip,p_tocTip)
{
	with (this.branding)
	{
		logoPath=p_logoPath
		logoUrl=p_logoUrl
		indexPath=p_indexPath
		indexUrl=p_indexUrl
		tocPath=p_tocPath
		tocUrl=p_tocUrl
		logoTip=p_logoTip
		idxTip=p_idxTip
		tocTip=p_tocTip
	}
}

function setAuthor(p_name,p_email,p_photo,p_url,p_tip)
{
	with (this.author)
	{
		name=p_name
		email=p_email
		photo=p_photo
		url=p_url
		tip=p_tip
	}
}

var _basePath=unescape((parent&&parent._initialUrl)?extrPath(parent._initialUrl):getPath(document))

function cPath(url)
{
	return calPath(_basePath,url,false)
}

function insPage(p_title,p_fileName,p_url,p_enhanced,p_commentText,p_biblio,p_bibUrl)
{
	if (p_enhanced==_NULL) p_enhanced=false
	with (this) if (currentChapter!=_NULL)
	{
		var pg=new _KB_Page(p_title,p_url,p_fileName,_NULL,p_enhanced,p_commentText,p_biblio,p_bibUrl)
		currentChapter.addItem(this,pg)
		if (!pg.isInDomain) externalPageCount++
		else internalPageCount++
		if (pg.url) pg.url=calPath(_basePath,pg.url,false)
		return pg
	}
}

function insPict(p_title,p_fileName,p_url,p_enhanced,p_commentText,w,h)
{
	if (p_enhanced==_NULL) p_enhanced=false
	with (this) if (currentChapter!=_NULL)
	{
		var pg=new _KB_Page(p_title,p_url,p_fileName,_NULL,p_enhanced,p_commentText)
		currentChapter.addItem(this,pg)
		pg.internal="pict"
		pg.w=w
		pg.h=h
		internalPageCount++
		if (pg.url) pg.url=calPath(_basePath,pg.url,false)
		return pg
	}
}

function pushCh(p_title,p_commentText)
{
	with (this)	if (currentChapter!=_NULL)
	{
		var newChapter=new _KB_Chapter(currentChapter,p_title,p_commentText)
		currentChapter.addItem(this,newChapter)
		currentChapter=newChapter
	}
}

function popCh()
{
	with (this) if (currentChapter!=_NULL) currentChapter=currentChapter.parent
}

function addSti(text,x,y,w,h,color)
{
	if (this.sticker==_NULL) this.sticker=new Array
	var sti=new Array
	sti["text"]=text
	sti["x"]=x
	sti["y"]=y
	sti["w"]=w
	sti["h"]=h
	sti["color"]=color
	this.sticker[this.sticker.length]=sti
	this.enhanced=true
}

function setAuthPage(p_title,p_fileName,p_url)
{
	with (this.authorPage)
	{
		title=entitifyString(p_title)
		oldTitle=p_title
		fileName=p_fileName
		url=p_url
		internal=_NULL
	}
}

function setAdv(p_title,p_fileName,p_url)
{
	this.advertPage=new _KB_Page(p_title,p_url,p_fileName,_NULL,false)
}

function openBk()
{
}

function openToc()
{
}

function closeToc()
{
}

function setTit(str)
{
	this.title=entitifyString(str)
	this.oldTitle=str
}

function setBkId(id)
{
	this.id=id
}

function KBInitEngine(bookVer,KBVer)
{
	return new _KB_Engine
}

function setPar(name,val,force)
{
	with(this)
	{
		params[name]=new Array
		params[name]["val"]=val
		params[name]["force"]=force
	}
}

function setDefSkin(skin,force) { this.setParam("skin",skin,force) }
function setDefLang(lang,force) { this.setParam("lang",lang,force) }
function setDefPage(page,force) { this.setParam("page",page,force) }
function setDefMode(mode,force) { this.setParam("mode",mode,force) }

function duplicateArray(src)
{
	var dst=new Array
	for (var i in src) dst[i]=src[i]
	return dst
}

function updateBook(ch,bk)
{
	if (bk==_NULL) bk=book

	with (bk)
	{
		var topLevel=(ch==chapter)
		if (topLevel)
		{
			pages.length=0
			tabs.length=1
			externalPageCount=0
			internalPageCount=0
		}
		
		for (var i=0;i<ch.items.length;i++)
		{
			var item=ch.items[i]
			pages[pages.length]=item
			item.page=pages.length
			if (topLevel&&item.isChapter) tabs[tabs.length]=item.page-1

			if (!item.isChapter&&(item.internal==_NULL))
			{
				if (!item.isInDomain) externalPageCount++
				else internalPageCount++
			}
			
			if (item.isChapter) updateBook(item,bk)
		}
	}
}

function duplicateItem(item,keepId)
{
	var ret
	if (item.isChapter)
	{
		ret=new _KB_Chapter(_NULL,item.oldTitle,item.commentText)
		for (var i in item.items) ret.items[ret.items.length]=duplicateItem(item.items[i],keepId)
	}
	else
		ret=new _KB_Page(item.oldTitle,item.url,item.fileName,item.internal,item.enhanced,item.commentText,item.biblio,item.bibUrl)
	
	if (keepId) ret.id=item.id
	return ret
}

function duplicateBook(src,dst)
{
	if  (dst==_NULL)
	{
		var engine=new _KB_Engine
		dst=engine.KBCreateBook(0,0,src.id,src.oldTitle,0,0)
	}
	else
	{
		dst.title=src.title
		dst.oldTitle=src.oldTitle
	}
		
	with (dst)
	{
		author=duplicateArray(src.author)
		branding=duplicateArray(src.branding)
		KBOpenToc()
		KBCloseToc()
		KBOpenBook()
		chapter.items.length=0
		var srcItems=src.chapter.items
		for (var i in srcItems) chapter.items[chapter.items.length]=duplicateItem(srcItems[i],true)
		updateBook(chapter,dst)
	}
	
	return dst
}
